package com.huaching.thselasticsearch.controller;

import org.apache.http.HttpHost;
import org.elasticsearch.action.get.GetRequest;
import org.elasticsearch.action.get.GetResponse;
import org.elasticsearch.action.search.SearchRequest;
import org.elasticsearch.action.search.SearchResponse;
import org.elasticsearch.client.RequestOptions;
import org.elasticsearch.client.RestClient;
import org.elasticsearch.client.RestHighLevelClient;
import org.elasticsearch.common.Strings;
import org.elasticsearch.index.query.QueryBuilders;
import org.elasticsearch.search.builder.SearchSourceBuilder;
import org.elasticsearch.search.fetch.subphase.FetchSourceContext;

import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ElasticSearchUtil {


//    public static String sqlSelect(String url, String  index, String sql){
//
//        if (url == null || url.isEmpty()){
//            return null;
//        }
//        if (sql == null || sql.isEmpty()){
//            return null;
//        }
//
//        Map<String, String> headerMap = new HashMap<>(4);
//        headerMap.put("Content-type", "application/json");
//
//        Map<String, String> paramsMap = new HashMap<>(4);
//        paramsMap.put("query", sql);
//        String jsonStr = JSONObject.toJSONString(paramsMap, SerializerFeature.WriteMapNullValue);
//
//        String httpUrl = url + "/_sql/translate?format=json";
//        String res = HttpUtil.postHeaderString(httpUrl, headerMap, jsonStr);
//
//        String httpUrl1 = url + "/" + index + "/_search";
//
//        return HttpUtil.postHeaderString(httpUrl1, headerMap, res);
//    }

    public static void main(String[] args) throws IOException {
        // System.out.println(ElasticSearchUtil.sqlSelect("http://47.97.200.228:9200", "api_visit_dev","SELECT responeBody FROM api_visit_dev limit 1"));


        RestHighLevelClient client = new RestHighLevelClient(
                RestClient.builder(
                        new HttpHost("47.97.200.228", 9200, "http")));


        GetRequest getRequest = new GetRequest("api_visit_dev");

         getRequest.id("k32YHWwBkEEehDN-Y5o4");
        // getRequest.fetchSourceContext(FetchSourceContext.DO_NOT_FETCH_SOURCE);


        String[] includes = Strings.EMPTY_ARRAY;
        String[] excludes = new String[]{"responeBody"};
        FetchSourceContext fetchSourceContext = new FetchSourceContext(true, includes, excludes);
        getRequest.fetchSourceContext(fetchSourceContext);

        // getRequest.storedFields("responeBody");
       //  GetResponse getResponse = client.get(getRequest, RequestOptions.DEFAULT);


        // System.out.println(getResponse.getSource());
        // String message = getResponse.getField("message").getValue();

        // IndexResponse indexResponse = client.index(request, RequestOptions.DEFAULT);


        /**
         * 搜索api
         */



        SearchRequest searchRequest = new SearchRequest("api_visit_dev");
        SearchSourceBuilder searchSourceBuilder = new SearchSourceBuilder();
        searchSourceBuilder.query(QueryBuilders.matchAllQuery());
        searchRequest.source(searchSourceBuilder);


        SearchResponse searchResponse = client.search(searchRequest, RequestOptions.DEFAULT);
        System.out.println(searchResponse.getHits().getHits());


        try {
            client.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

}
